unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, IniFiles, ComCtrls, Menus, unit2, unit4,
  ImgList, unit5, unit6;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    ComboBox1: TComboBox;
    RichEdit1: TRichEdit;
    PopupMenu1: TPopupMenu;
    N3: TMenuItem;
    FontDialog1: TFontDialog;
    ColorDialog1: TColorDialog;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    N4: TMenuItem;
    N6: TMenuItem;
    PopupMenu2: TPopupMenu;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    N14: TMenuItem;
    N15: TMenuItem;
    N2: TMenuItem;
    N10: TMenuItem;
    N16: TMenuItem;
    N17: TMenuItem;
    N18: TMenuItem;
    N11: TMenuItem;
    N19: TMenuItem;
    N20: TMenuItem;
    N21: TMenuItem;
    Timer1: TTimer;
    N1: TMenuItem;
    procedure Panel1Resize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure N3Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure N7Click(Sender: TObject);
    procedure N12Click(Sender: TObject);
    procedure N13Click(Sender: TObject);
    procedure N14Click(Sender: TObject);
    procedure N15Click(Sender: TObject);
    procedure N10Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShortCut(var Msg: TWMKey; var Handled: Boolean);
    procedure N11Click(Sender: TObject);
    procedure N20Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ComboBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure N1Click(Sender: TObject);
    procedure RichEdit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure N17Click(Sender: TObject);
    procedure N18Click(Sender: TObject);
  private
    procedure InsertHistory;
    procedure AddLines(s: string);
    function nowa: string;
    procedure SaveINI;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Ini: TIniFile;
  CalculatorDir:string;
implementation

uses Unit3;

{$R *.dfm}

procedure InitForm5;
begin
 Form4.ReadForm(ini,'Form5',TForm(Form5));
end;

procedure TForm1.Panel1Resize(Sender: TObject);
begin
 self.ComboBox1.Width:=self.Panel1.Width;
 self.ComboBox1.Height:=self.Panel1.Height;
end;

procedure TForm1.SaveINI;
var i:integer;
begin
 ini.WriteInteger('Timer','Interval',Timer1.Interval);
 ini.WriteBool('Timer','Enabled',Timer1.Enabled);

 Form4.WriteForm(ini,'Form5',Form5);

 Form3.Vars.Strings.SaveToFile(CalculatorDir+'history.var');
 Form4.WriteForm(ini,'Form3',Form3);

 Form4.WriteForm(ini,'Form1',Form1);

 ini.WriteInteger('RichEdit','color',RichEdit1.Color);
 ini.WriteInteger('ComboBox','color',ComboBox1.Color);

 Form4.WriteFont(ini,'ComboBox',ComboBox1.Font);
 Form4.WriteFont(ini,'RichEdit',RichEdit1.Font);

 for i:=1 to FontCount do Form4.WriteFont(ini,'Form4.Font'+IntToStr(i),Fonts[i]);

 ComboBox1.Items.SaveToFile(CalculatorDir+'history.txt');
 RichEdit1.Lines.SaveToFile(CalculatorDir+'history.rtf');
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 SaveIni;
end;

procedure TForm1.InsertHistory;
var n:integer;
    s:string;
begin
  s := combobox1.text;
  n := combobox1.Items.IndexOf(s);
  if n<>-1 then
    combobox1.Items.Delete( n );
  if s <> '' then
    combobox1.Items.Insert(0,s);
end;

procedure TForm1.AddLines(s:string);
var i,n:integer;
begin

  n:=length(RichEdit1.Text);

  RichEdit1.Lines.Add(s);

  RichEdit1.SelStart:=n;

  for i:=1 to length(s) do
  begin
   RichEdit1.SelLength:=1;
   Form4.GetFontAttr(s[i], RichEdit1.SelAttributes);
   RichEdit1.SelStart:=RichEdit1.SelStart+1;
  end;
end;

procedure TForm1.N3Click(Sender: TObject);
begin
 close
end;

procedure TForm1.N4Click(Sender: TObject);
begin
 ColorDialog1.Color:=RichEdit1.Color;
 if ColorDialog1.Execute then
  RichEdit1.Color:=ColorDialog1.Color;
end;

procedure TForm1.N6Click(Sender: TObject);
begin
 SaveDialog1.Filter:='  :) (*.rtf)|*.rtf| (*.*)|*.*';
 SaveDialog1.DefaultExt:='*.rtf';
 if SaveDialog1.Execute then
  RichEdit1.Lines.SaveToFile(SaveDialog1.FileName);
end;

procedure TForm1.N7Click(Sender: TObject);
begin
 SaveDialog1.Filter:='   :) - (*.txt)|*.txt|   (*.*)|*.*';
 SaveDialog1.DefaultExt:='*.txt';
 if SaveDialog1.Execute then
  ComboBox1.Items.SaveToFile(SaveDialog1.FileName);
end;

procedure TForm1.N12Click(Sender: TObject);
begin
 FontDialog1.Font:=ComboBox1.Font;
 if FontDialog1.Execute then
  Combobox1.Font:=FontDialog1.Font;
end;

procedure TForm1.N13Click(Sender: TObject);
begin
 ColorDialog1.Color:=ComboBox1.Color;
 if ColorDialog1.Execute then
  Combobox1.Color:=ColorDialog1.Color;
end;

procedure TForm1.N14Click(Sender: TObject);
begin
 RichEdit1.Lines.SaveToFile('history '+nowa+'.rtf');
 RichEdit1.Lines.Clear;
end;

function TForm1.nowa: string;
begin
 result:=DateTimeToStr(now);
 while pos(':',result)>0 do  result[Pos(':', result)] := '@';
end;

procedure TForm1.N15Click(Sender: TObject);
begin
 ComboBox1.Items.SaveToFile('history '+nowa+'.txt');
 ComboBox1.Items.Clear;
end;

procedure TForm1.N10Click(Sender: TObject);
begin
 if N10.Checked then
  Form1.FormStyle:=fsNormal
 else
  Form1.FormStyle:=fsStayOnTop;
 N10.Checked:=not N10.Checked;
end;

procedure LoadForm3;
begin
 if FileExists(CalculatorDir+'history.var') then
   Form3.Vars.Strings.LoadFromFile(CalculatorDir+'history.var');
 Form4.ReadForm(ini,'Form3',TForm(Form3));
end;

procedure TForm1.FormCreate(Sender: TObject);
var i:integer;
begin
 getdir(0,CalculatorDir);
 CalculatorDir:=CalculatorDir+'\';

 CalculatorDirF5:=CalculatorDir;

 ComboBox1.Left:=0;
 ComboBox1.Top:=0;

 Panel1.Width:=ComboBox1.Width+10;
 Panel1.Height:=ComboBox1.Height;

 OnLoadForm3:=@LoadForm3;
 OnInitForm5:=@InitForm5;

 ini:=TINIFile.Create(CalculatorDir+'history.ini');

 __ini:=ini;

 Timer1.Interval:=ini.ReadInteger('Timer','Interval',Timer1.Interval);
 Timer1.Enabled:=ini.ReadBool('Timer','Enabled',Timer1.Enabled);

 Form4.ReadForm(ini,'Form1',TForm(Form1));

 N10.Checked:=Form1.FormStyle=fsStayOnTop;

// Form4:=TForm4.Create(Form1);

 RichEdit1.Color:=ini.ReadInteger('RichEdit','color',RichEdit1.Color);
 ComboBox1.Color:=ini.ReadInteger('ComboBox','color',ComboBox1.Color);

 ComboBox1.Font:=Form4.ReadFont(ini,'ComboBox',ComboBox1.Font);
 RichEdit1.Font:=Form4.ReadFont(ini,'RichEdit',RichEdit1.Font);

 for i:=1 to FontCount do Fonts[i]:= TFont.Create;
 for i:=1 to FontCount do Fonts[i]:= Form4.ReadFont(ini,'Form4.Font'+IntToStr(i),Fonts[i]);

 if FileExists(CalculatorDir+'history.rtf') then
  RichEdit1.Lines.LoadFromFile(CalculatorDir+'history.rtf');
 if FileExists(CalculatorDir+'history.rtf') then
  ComboBox1.Items.LoadFromFile(CalculatorDir+'history.txt');

 RichEdit1.SelStart:=length(RichEdit1.Text)-2;

 // Exit
 N3.ShortCut:=ShortCut(Word('X'), [ssAlt]);
 N9.ShortCut:=ShortCut(Word('X'), [ssAlt]);
 // save all
 N11.ShortCut:=ShortCut(Word('A'), [ssAlt]);
 N19.ShortCut:=ShortCut(Word('A'), [ssAlt]);
 // clear
 N14.ShortCut:=ShortCut(Word('E'), [ssAlt]);
 N6 .ShortCut:=ShortCut(Word('S'), [ssAlt]);

// RichEdit1.ScrollBy();
end;

procedure TForm1.FormShortCut(var Msg: TWMKey; var Handled: Boolean);
begin
if msg.Result=0 then
  case Msg.CharCode of
   VK_ESCAPE: Form1.WindowState:= wsMinimized;

   VK_F3: N4.OnClick(Form1);
   VK_F5: N10.OnClick(Form1);
   VK_F1: N17Click(Form1);

   VK_F9: N18Click(Form1);

   VK_F6: N12.OnClick(Form1);
   VK_F7: N13.OnClick(Form1);

   VK_F10: N1Click(Form1);
   VK_F11: N20Click(Form1);
  end;
end;

procedure TForm1.N11Click(Sender: TObject);
begin
 N15.OnClick(N11);
 N14.OnClick(N11);
 Form1.SaveIni;
 Form3.Vars.Strings.Clear;
 Form3.StatusBar1.Panels[0].Text:='1';
 CopyFile(PChar(CalculatorDir+'history.ini'), PChar(CalculatorDir+'history '+nowa+'.ini'),true);
end;

procedure TForm1.N20Click(Sender: TObject);
begin
 if Form1.FormStyle = FsStayOnTop then
  Form4.ShowModal
 else
  Form4.Show
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
 SaveIni;
end;

procedure TForm1.ComboBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var s:string;
begin
 if (key=Word('S')) and ([ssAlt]=Shift) then N6.OnClick(Form1)
 else if (key=Word('E')) and ([ssAlt]=Shift) then N14.OnClick(Form1)
 else if key = 13 then begin

  s := combobox1.Text;

  AddLines(s);

  InsertHistory;

  ComboBox1.Text:='';

  if s = '' then exit;

  s := calculate(s);

  AddLines(s);
 end;
end;

procedure TForm1.N1Click(Sender: TObject);
begin
 if Form1.FormStyle = FsStayOnTop then
  Form3.ShowModal
 else
  Form3.Show
end;

procedure TForm1.RichEdit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if (key=Word('S')) and ([ssCtrl] = Shift) then N7Click(Form1)
 else if (key=Word('E')) and ([ssCtrl] = Shift) then begin N15Click(Form1); key:=word('1') end
end;

procedure TForm1.N17Click(Sender: TObject);
begin
 if Form1.FormStyle = FsStayOnTop then
  Form5.ShowModal
 else
  Form5.Show
end;

procedure TForm1.N18Click(Sender: TObject);
begin
 Form6.ShowModal;
end;

end.
