unit Unit2;

interface

uses Classes, unit3;

type elem = class
 s: string;
 f: extended;
 function isfloat: boolean;
end;

type tree = class
 a: elem;

 left, right:tree;

    function atom(var s: elem): boolean; overload;
    function unary(s: string; var right: tree): boolean;
    function node(var left: tree; s: string; var right: tree): boolean;
  end;

function calculate(s: string):string;

implementation

uses Dialogs, sysutils, math;

const size = 512;
var p: pchar;
    atom_1: tree;
    atom_0: tree;

// ----------------------------- me ---------------------------------
type me = class
 s:string;
 constructor Create(m:string);
end;

constructor me.Create(m:string);
begin
 s:=m;
end;

// --------------------------------- list -------------------------------
type list = class
 next:list;
 a: string;
end;

function fr(s:string; l:list):list;
begin
 result:=list.Create;
 result.a:=s;
 result.next:=l;
end;

// -------------------- create tree --------------
function isdigit(c:char):boolean; forward;

function misdigit(a:string):boolean;
begin
 if a='' then result:=false
 else if isdigit(a[1]) then result:=true
 else if (a[1]='-') and isdigit(a[2]) then result:=true
 else result:=false
end;

procedure a2elem(var a:elem);
begin
 if misdigit(a.s) then begin
  a.f := strtofloat(a.s);
  a.s := '';
 end;
end;

function atom(a:string):tree; overload;
begin
 result:=tree.Create;
 result.a:= elem.Create;
 result.a.s:=a;
 a2elem(result.a);
 result.left:=nil;
 result.right:=nil;
end;

function atom(a:extended):tree; overload;
begin
 result:=tree.Create;
 result.a:= elem.Create;
 result.a.s:='';
 result.a.f := a;
 result.left:=nil;
 result.right:=nil;
end;

function unary(a:string; right:tree):tree; overload;
begin
 result:=tree.Create;
 result.a:=elem.Create;
 result.a.s:=a;
 a2elem(result.a);
 result.left:=nil;
 result.right:=right;
end;

function unary(a:extended; right:tree):tree; overload;
begin
 result:=tree.Create;
 result.a:=elem.Create;
 result.a.s:='';
 result.a.f:=a; 
 result.left:=nil;
 result.right:=right;
end;


function node(left:tree; a:string; right:tree):tree; overload;
begin
 result:=tree.Create;
 result.a:=elem.Create;
 result.a.s:=a;
 a2elem(result.a);
 result.left:=left;
 result.right:=right;
end;

function node(left:tree; a:extended; right:tree):tree; overload;
begin
 result:=tree.Create;
 result.a:=elem.Create;
 result.a.s:='';
 result.a.f:=a;
 result.left:=left;
 result.right:=right;
end;

function node(left:tree; a:elem; right:tree):tree; overload;
begin
 result:=tree.Create;
 result.a:=a;
 result.left:=left;
 result.right:=right;
end;

// -------------------- lex ------------------
function isalpha(c:char):boolean;
begin
 result:=  ('A'<=c) and (c<='Z') or ('a'<=c) and (c<='z') or (c = '_');
end;

function isdigit(c:char):boolean;
begin
 result:=  ('0'<=c) and (c<='9');
end;

function isalnum(c:char):boolean;
begin
 result:=  isalpha(c) or isdigit(c);
end;

function num(var s:string): boolean;
begin
 result:=true;
 if not isdigit(p^) then begin result:=false; exit; end;
 while isdigit(p^) do
 begin
  s:=s+p^;
  inc(p);
 end;

 if (p^ = '.') or (p^ = ',') then begin
  if not isdigit(p[1]) then exit;
  s:=s+',';
  inc(p);
  while isdigit(p^) do
  begin
   s:=s+p^;
   inc(p);
  end; // while
 end; // if
end;

function id(var s:string):boolean;
begin
 result:=true;
 if not isalpha(p^) then begin result:=false; exit; end;
 while isalnum(p^) do
 begin
  s:=s+p^;
  inc(p);
 end;
end;

function isop(c:string):boolean;
begin
 result:=true;
 if c = '' then begin result:=false; exit end;
 case c[1] of
 '''': exit;
 '!': exit;
 '=': exit;
 '+': exit;
 '-': exit;
 '*': exit;
 '/': exit;
 '^': exit;
 '@': exit;
 '(': exit;
 ')': exit;
 end;
 result:=false;
end;

procedure space;
begin
 while p^ = ' ' do inc(p);
end;

function tree.atom(var s:elem):boolean;
begin
 result := (self.left = nil) and (self.right = nil);
 s := self.a;
end;

function tree.unary(s:string; var right:tree):boolean;
begin
 result := (self.left = nil) and (self.right <> nil) and (s = self.a.s);
 right := self.right;
end;

function tree.node(var left:tree; s:string; var right:tree):boolean;
begin
 result := (self.left <> nil) and (self.right <> nil) and (s = self.a.s);
 left:=self.left;
 right:=self.right;
end;

function diff(f:tree; x:string):tree;
var s:elem;
    u, a: tree;
begin

 if f.atom(s) and (s.s <> x) then result:=atom_0
 else if f.atom(s) and (s.s = x) then result:=atom_1
 else if f.node(a,'^',u) and a.atom(s) and (s.s = 'e') then result:=
  node(f,'*',diff(u,x))
 else if f.node(u,'^',a) and a.atom(s) and (s.s<>x) then result:=
  node(
   node(a,'*',
    node(u,'^',
     node(a,'-',atom_1)
    )
   ),'*',diff(u,x)
  )
 else if f.unary('-',u) then result:= unary('-', diff(u,x))
 else if f.unary('@',u) then result:=
  node(atom_1, '/',
   node(atom('2'),'*',
    unary('@',u)
   )
  )
 else if f.node(a,'^',u) and a.atom(s) and (s.s<>x) then result:=
  node(
   node(
    node(a,'^',u),'*',unary('ln',a)
   ),'*',diff(u,x)
  )
 else if f.unary('ln',u) then result :=
  node(
   node(atom_1,'/',u), '*', diff(u,x)
  )
 else if f.node(a,'log',u) then result:=
  node(
   node( atom_1, '/',
    node(u,'*', unary('ln',a) )
   ),'*', diff(u,x)
  )
 else if f.unary('sin',u) then result:= node(unary('cos',u),'*',diff(u,x))
 else if f.unary('cos',u) then result:= node(unary('-',unary('sin',u)),'*',diff(u,x))
 else if f.unary('tg',u) then result:=
  node(
   node(
    atom_1,'/', node(unary('cos',u),'^',atom('2'))
   ),'*',diff(u,x)
  )
 else if f.unary('tg',u) then result:= unary('-',
   node(
    node(
     atom_1,'/', node(unary('sin',u),'^',atom('2'))
    ),'*',diff(u,x)
   )
  )
 else if f.unary('arcsin',u) then result:=
  node(
   node(atom_1,'/',
    unary('@',
     node( atom_1,'-',
      node(u,'^', atom('2') )
     )
    )
   ),'*',diff(u,x)
  )
 else if f.unary('arccos',u) then result:= unary('-',
   node(
    node(atom_1,'/',
     unary('@',
      node( atom_1,'-',
       node(u,'^', atom('2') )
      )
     )
    ),'*',diff(u,x)
   )
  )
 else if f.unary('arctg',u) then result:=
  node(
   node(atom_1,'/',
    node( atom_1,'+',
     node(u,'^', atom('2') )
    )
   ),'*',diff(u,x)
  )
 else if f.unary('arcctg',u) then result:= unary('-',
   node(
    node(atom_1,'/',
     node( atom_1,'+',
      node(u,'^', atom('2') )
     )
    ),'*',diff(u,x)
   )
  )
 else if f.node(a,'*',u) and a.atom(s) then result:= node(a,'*',diff(u,x))
 else if f.node(a,'+',u) then result:= node( diff(a,x), '+', diff(u,x) )
 else if f.node(a,'-',u) then result:= node( diff(a,x), '-', diff(u,x) )
 else if f.node(a,'*',u) then result:=
  node(
   node( diff(a,x), '*', u ), '+',
   node( diff(u,x), '*', a )
  )
 else if f.node(a,'/',u) then result:=
  node(
   node(
    node( diff(a,x), '*', u ), '-',
    node( diff(u,x), '*', a )
   ),'/', node(u,'^',atom('2'))
  )
 else if f.node(a,'@',u) then result:= diff(
  node(u,'^', node(atom_1,'/',a) ), x)
 else  result:=atom(' -   ,    -   ;)');
end;


// ---------------------------- str2list --------------------------------

{function isalpharu(c:char): boolean;
begin
 result:= (''<=c) and (c<='');
end;

function numv(var s:string; var m:string): boolean;
var pp: pchar;
begin
 pp:=p;
 result:=false;
 if num(s) and id(m) then result:= true
 else p:=pp;
end;
}
function str2list:list;
var s:string;
begin
 space;
 if p^ = #0 then result:=nil
// else if numv(s, m) then result:= fr(m, fr(s, str2list))
 else if num(s) then result:=fr(s, str2list )
 else if id(s) then result:=fr(s, str2list )
 else if isop(p^) then begin s:=p^; inc(p); result:=fr(s, str2list); end
 else result:=fr('  `'+p^+'''',nil);
end;

// ------------------------------- grammatic -----------------------------
function next(x:list):list;
begin
 if x = nil then result:=nil
 else result:=x.next
end;

function eq(x:list; s:string):boolean;overload;
begin
 if x = nil then result:=false
 else result:= x.a = s;
end;

function alef(x:list):char;
begin
 if x = nil then result:=#0
 else result:=x.a[1]
end;

function isuop(x:list): boolean;
const
 count = 14;
 a: array [1..count] of string = ('!','-','@','ln','sin','cos','tg','ctg',
 'arcsin','arccos','arctg','arcctg','rad','deg');
var i:integer;
begin
 for i:=1 to count do if x.a = a[i] then begin
  result:=true;
  exit;
 end;
 result:=false;
end;

function t0(x1:list; var x2:list; var v:tree):boolean; forward;
function t_1(x1:list; var x2:list; var v:tree):boolean; forward;
function t1(x1:list; var x2:list; var v:tree):boolean; forward;
function t2(x1:list; var x2:list; var v:tree):boolean; forward;
function t3(x1:list; var x2:list; var v:tree):boolean; forward;
function t4(x1:list; var x2:list; var v:tree):boolean; forward;
function t5(x1:list; var x2:list; var v:tree):boolean; forward;


function t0(x1:list; var x2:list; var v:tree):boolean;
var x:list;
    a,b:tree;
begin
 if x1 = nil then result:=false
 else if t_1(x1,x,a) and eq(x,'=') and t0(next(x),x2,b)
 then begin
  v:=node(a,x.a,b);
  result:=true
 end else if t_1(x1,x2,v) then result:=true
 else result:=false;
end;

function t_1(x1:list; var x2:list; var v:tree):boolean;
var x:list;
    a,b:tree;
begin
 if x1 = nil then result:=false
 else if t1(x1,x,a) and eq(x,'''') and t_1(next(x),x2,b)
 then begin
  v:=node(a,x.a,b);
  result:=true
 end else if t1(x1,x2,v) then result:=true
 else result:=false;
end;

function t1(x1:list; var x2:list; var v:tree):boolean;
var x:list;
    a,b:tree;
begin
 if x1 = nil then result:=false
 else if t2(x1,x,a) and (eq(x,'+') or eq(x,'-')) and t1(next(x),x2,b)
 then begin
  v:=node(a,x.a,b);
  result:=true
 end else if t2(x1,x2,v) then result:=true
 else result:=false;
end;

function t2(x1:list; var x2:list; var v:tree):boolean;
var x:list;
    a,b:tree;
begin
 if x1 = nil then result:=false
 else if t3(x1,x,a) and (eq(x,'*') or eq(x,'/')) and t2(next(x),x2,b)
 then begin
  v:=node(a,x.a,b);
  result:=true
 end else if t3(x1,x2,v) then result:=true
 else result:=false;
end;

function t3(x1:list; var x2:list; var v:tree):boolean;
var x:list;
    a,b: tree;
begin
 if x1 = nil then result:=false
 else if t4(x1,x,a) and (eq(x,'@') or eq(x,'^')) and t3(next(x),x2,b)
 then begin
  v:=node(a,x.a,b);
  result:=true
 end else if t4(x1,x2,v) then result:=true
 else result:=false;
end;

function t4(x1:list; var x2:list; var v:tree):boolean;
var x:list;
    a,b: tree;
begin
 if x1 = nil then result:=false
 else if t5(x1,x,a) and eq(x,'log') and t4(next(x),x2,b)
 then begin
  v:=node(a,x.a,b);
  result:=true
 end else if t5(x1,x2,v) then result:=true
 else result:=false;
end;

function t5(x1:list; var x2:list; var v:tree):boolean;
var x: list;
    b: tree;
begin
 if x1 = nil then result:=false
 else if eq(x1,'(') and t0(next(x1),x,v) and eq(x, ')') then
 begin
  x2:=x.next;
  result:=true;
 end else if isuop(x1) and t5(next(x1),x2,b)
 then begin
  v:=unary(x1.a,b);
  result:=true
 end else if isalnum(alef(x1)) then begin
  x2:=x1.next;
  v:=atom( Form3.get( x1.a ) );
  result:=true
 end else result:=false;
end;

function prio(c:string):integer;
begin
{??????????????????????????????????????????????????????????}
 if c = '' then raise me.Create(' prio   ');

 case c[1] of
  '=': result:=1;
  '''': result:=2;
  '+','-': result:=3;
  '*','/': result:=4;
  '^','@': result:=5;
  else if c = 'log' then result:=6 else result:=7;
 end;
end;

function u2s(a:string):string;
begin
 if isalpha(a[1]) then result:=a+' '
 else result:=a;
end;

function r2s(a:string):string;
begin
 if isalpha(a[1]) then result:=' '+a
 else result:=a;
end;

function m2s(a:string):string;
begin
 if isalpha(a[1]) then result:=' '+a+' '
 else result:=a;
end;

function elem2a(a:elem):string;
begin
 if a.isfloat then result:=floattostr(a.f)
 else result:=a.s;
end;

function tree2str(x:tree):string;
begin
 if x=nil then result:=''
 else if (x.left = nil) and (x.right = nil) then
      result:= elem2a(x.a)
 else if (x.left = nil) and not isop(x.right.a.s) then
      result:= u2s(elem2a(x.a)) + tree2str(x.right)
 else if (x.left = nil) then
      result:= elem2a(x.a) + '(' + tree2str(x.right) + ')'
 else if (prio(x.a.s) > prio(x.right.a.s)) and
         (prio(x.a.s) > prio(x.left.a.s)) and
         isop(x.right.a.s) and isop(x.left.a.s)
 then
   result:= '('+tree2str(x.left)+')'+
            m2s(elem2a(x.a))+
            '('+tree2str(x.right)+')'
 else if (prio(x.a.s) > prio(x.right.a.s)) and isop(x.right.a.s)
 then
 result:=tree2str(x.left)+
            m2s(elem2a(x.a))+
            '('+tree2str(x.right)+')'
 else if (prio(x.a.s) > prio(x.left.a.s)) and isop(x.left.a.s)
 then
  result:= '('+tree2str(x.left)+')'+
            m2s(elem2a(x.a))+
            tree2str(x.right)
 else
  result:= tree2str(x.left)+
            m2s(elem2a(x.a))+
            tree2str(x.right)
end;

function factorial(n:extended):extended;
begin
 if n<=0 then result:=1
 else result:=n*factorial(n-1)
end;

function calc(x:tree):tree;
var a,b,l,r: tree;
    s: elem;
begin
 if x.atom(s) then result:=x
 else if x.unary('deg',b) then begin
  a:=calc(b);
  if a.atom(s) and s.isfloat then
   result:=atom(radtodeg(s.f))
  else
   result:=unary('deg',a)
 end else if x.unary('rad',b) then begin
  a:=calc(b);
  if a.atom(s) and s.isfloat then
   result:=atom(degtorad(s.f))
  else
   result:=unary('rad',a)
 end else if x.unary('-',b) then begin
  a:=calc(b);
  if a.atom(s) and s.isfloat then
   result:=atom(-s.f)
  else
   result:=unary('-',a)
 end else if x.unary('ln',b) then begin
  a:=calc(b);
  if a.atom(s) and s.isfloat and (s.f>0) then
   result:=atom( ln(s.f) )
  else
   result:=unary('ln',a)
 end else if x.unary('!',b) then begin
  a:=calc(b);
  if a.atom(s) and s.isfloat then
   result:=atom( factorial( s.f ) )
  else
   result:=unary('!',a)
 end else if x.unary('@',b) then begin
  a:=calc(b);
  if a.atom(s) and s.isfloat then
   result:=atom( sqrt( s.f ) )
  else
   result:=unary('@',a)
 end else if x.unary('sin',b) then begin
  a:=calc(b);
  if a.atom(s) and s.isfloat then
   result:=atom( sin( s.f ) )
  else
   result:=unary('sin',a)
 end else if x.unary('cos',b) then begin
  a:=calc(b);
  if a.atom(s) and s.isfloat then
   result:=atom( cos( s.f ) )
  else
   result:=unary('cos',a)
 end else if x.unary('tg',b) then begin
  a:=calc(b);
  if a.atom(s) and s.isfloat then
   result:=atom( tan( s.f ) )
  else
   result:=unary('tg',a)
 end else if x.unary('ctg',b) then begin
  a:=calc(b);
  if a.atom(s) and s.isfloat then begin
   if s.f = 0 then
    result:=atom('infinity')
   else result:=atom( cotan( s.f ) )
  end else
   result:=unary('ctg',a)
 end else if x.unary('arccos',b) then begin
  a:=calc(b);
  if a.atom(s) and s.isfloat then begin
   if not((-1 <= s.f) and (s.f <= 1)) then
    result:=atom('arccos range [-1,1]')
   else result:=atom( arccos( s.f ) )
  end else
   result:=unary('arccos',a)
 end else if x.unary('arcsin',b) then begin
  a:=calc(b);
  if a.atom(s) and s.isfloat then
   if not((-1 <= s.f) and (s.f <= 1)) then
    result:=atom('arcsin range [-1,1]')
   else result:=atom( arcsin( s.f ) )
  else
   result:=unary('arcsin',a)
 end else if x.unary('arctg',b) then begin
  a:=calc(b);
  if a.atom(s) and s.isfloat then
   result:=atom( arctan( s.f ) )
  else
   result:=unary('arctg',a)
 end else if x.unary('arcctg',b) then begin
  a:=calc(b);
  if a.atom(s) and s.isfloat then
   result:=atom( pi/2 - arctan( s.f ) )
  else
   result:=unary('arcctg',a)
 end else if x.node(a,'=',b) then begin
  r:=calc(b);
  if not (a.atom(s) and not s.isfloat) then raise me.Create('       ');
  if not (r.atom(s) and s.isfloat) then raise me.Create('   ');
  Form3.put(a.a.s,elem2a(r.a));
  result:=r;
 end else if x.node(a,'+',b) then begin
  l:=calc(a);
  r:=calc(b);
  if l.atom(s) and s.isfloat and
     r.atom(s) and s.isfloat
  then result:=atom( l.a.f+r.a.f )
  else result:=node(l,'+',r)
 end else if x.node(a,'-',b) then begin
  l:=calc(a);
  r:=calc(b);
  if l.atom(s) and s.isfloat and
     r.atom(s) and s.isfloat
  then result:=atom( l.a.f - r.a.f )
  else result:=node(l,'-',r)
 end else if x.node(a,'*',b) then begin
  l:=calc(a);
  r:=calc(b);
  if l.atom(s) and s.isfloat and
     r.atom(s) and s.isfloat
  then result:=atom( l.a.f * r.a.f )
  else result:=node(l,'*',r)
 end else if x.node(a,'/',b) then begin
  l:=calc(a);
  r:=calc(b);
  if l.atom(s) and s.isfloat and
     r.atom(s) and s.isfloat
  then begin
       if (l.a.f = 0) and (r.a.f = 0) then
         result:=atom('uncertainty')
       else if r.a.f = 0 then
         result:=atom('infinity')
       else
         result:=atom( l.a.f/r.a.f )
  end else result:=node(l,'/',r)
 end else if x.node(a,'^',b) then begin
  l:=calc(a);
  r:=calc(b);
  if l.atom(s) and s.isfloat and
     r.atom(s) and s.isfloat
  then result:=atom( power(l.a.f, r.a.f) )
  else result:=node(l,'^',r)
 end else if x.node(a,'@',b) then begin
  l:=calc(a);
  r:=calc(b);
  if l.atom(s) and s.isfloat and
     r.atom(s) and s.isfloat
  then begin
   if l.a.f < 0 then result:=atom('imaginary unit')
   else if (l.a.f = 0) and (r.a.f = 0) then result:=atom('uncertainty')
   else if l.a.f = 0 then result:=atom('infinity')
   else result:=atom( power(r.a.f, 1/l.a.f) )
  end else result:=node(l,'@',r)
 end else if x.node(a,'log',b) then begin
  l:=calc(a);
  r:=calc(b);
  if l.atom(s) and s.isfloat and
     r.atom(s) and s.isfloat
  then begin
   if l.a.f < 0 then result:= atom('     0-')
   else if l.a.f = 1 then result:= atom('      1-')
   else if r.a.f < 0 then result:= atom('      ')
   else result:=atom( logn(l.a.f, r.a.f) )
  end else result:=node(l,'log',r)
 end else if x.node(a,'''',b) and b.atom(s) and not s.isfloat
 then result:=calc(diff(a, s.s))
 else if x.node(a,'''',b) then raise me.Create(' ''     ')
 else result:=x;
end;

function biop(t:tree):boolean;
begin
 result:=(t.right<>nil) and (t.left<>nil)
end;

function right2left(a:tree):tree;
begin
 if a = nil then result:=nil
 else if a.right = nil then
  result:=node( right2left(a.left),a.a,right2left(a.right) )
 else if biop(a.right) and (prio(a.a.s)=prio(a.right.a.s)) then
  result:=right2left( node( node(a.left,a.a,a.right.left) ,a.right.a, a.right.right) )
 else result:=node( right2left(a.left),a.a,right2left(a.right) )
end;

function eq(a:tree; s:string):boolean; overload;
begin
 if a = nil then result:=false
 else if (a.left<>nil) or (a.right<>nil) then result:=false
 else if a.a.isfloat and misdigit(s) then result:= a.a.f = strtofloat(s)
 else result := a.a.s = s
end;

function mini(x:tree):tree;
var a,b:tree;
begin
 if x = nil then begin result:=nil; exit end;

 a:=mini(x.left);
 b:=mini(x.right);
 x:=node(a,x.a,b);

 if x.node(a,'+',b) and eq(a,'0') then result:=b
 else if x.node(a,'+',b) and eq(b,'0') then result:=a
 else if x.node(a,'-',b) and eq(a,'0') then result:=unary('-',b)
 else if x.node(a,'-',b) and eq(b,'0') then result:=a
 else if x.node(a,'*',b) and (eq(a,'0') or eq(b,'0')) then result:=atom_0
 else if x.node(a,'/',b) and eq(a,'0') then result:=atom_0
 else if x.node(a,'/',b) and eq(b,'1') then result:=a
 else if x.node(a,'*',b) and eq(b,'1') then result:=a
 else if x.node(a,'*',b) and eq(a,'1') then result:=b
 else if x.node(a,'^',b) and eq(a,'0') then result:=atom_0
 else if x.node(a,'^',b) and eq(b,'0') then result:=atom_1
 else if x.node(a,'^',b) and eq(b,'1') then result:=a
 else if x.node(a,'^',b) and eq(a,'1') then result:=atom_1
 else if x.node(a,'@',b) and eq(a,'0') then result:=atom_1
 else if x.node(a,'@',b) and eq(a,'1') then result:=b
 else if x.node(a,'@',b) and eq(b,'1') then result:=atom_1
 else if x.node(a,'log',b) and eq(b,'1') then result:=atom_0
 else result:=x;
end;

{/** !     prio ( diff),
       **/}
function iskop(a:string):boolean;
begin
 if a = '+' then result:= true ...
 else raise me.Create('[  '+a+']') 
end;

function balance(f:tree):tree;
var s:elem;
begin
 if f.atom(s) then result:=f
 else if f.left = nil then result:=f
 else if f.left.atom(s) and not s.isfloat
     and f.right.atom(s) and s.isfloat
 then begin
  if  iskop(f.a.s) then result:=
  else result:= 
 end else if (prio(f.a.s)=prio(f.right.a.s)) then
end;

function calculate(s: string):string;
var a:tree;
    x1,x2: list;
begin
 if s = '' then begin result:=''; exit; end;

 try

 p:=pchar(s);

 x1:=str2list;

 if t0(x1,x2,a) then begin
  if x2 <> nil then result:=tree2str(a)+',   - !'
  else begin
   a:=right2left(a);
   a:=calc(a);
   a:=mini(a);
   result:=tree2str(a)
  end
 end else result:= '  !';

 except
  on E:me do result:=E.s;
 end;

end;

{ elem }

function elem.isfloat: boolean;
begin
 if self.s = '' then result:= true
 else result:= false
end;

begin
 atom_1 := atom(1);
 atom_0 := atom(0);
end.
